Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c	(revision 331)
@@ -1854,13 +2479,117 @@
 	}
 
+#ifdef USE_PING
+
+/*
+ *  ping コマンド
+ */
+
+void
+dbg_cons_ping_comd (ID portid, char *line)
+{
+	int_t	tmo, size;
+	char	apip = DEFAULT_API_PROTO;
+
+#if defined(SUPPORT_INET6)
+	T_IN6_ADDR	addr;
+#if defined(SUPPORT_INET4)
+	T_IN4_ADDR	addr4;
+#endif
+#else
+	T_IN4_ADDR	addr;
+#endif
+
+#if defined(PING_CFG_I6RLP)
+
+	static const char i6rlp_pmtu_str1[] = " FF1E::1:2 1 1452";
+	static const char i6rlp_pmtu_str2[] = " FF1E::1:2 1 1352";
+	static const char i6rlp_pmtu_str3[] = " fe80::0200:00ff:fe00:0100 1 2";
+
+	if      (apip == '1')
+		strcpy(line, i6rlp_pmtu_str1);
+	else if (apip == '2')
+		strcpy(line, i6rlp_pmtu_str2);
+	else if (apip == '3')
+		strcpy(line, i6rlp_pmtu_str3);
+
+#endif	/* of #ifdef PING_CFG_I6RLP */
+
+#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
+
+	if ('0' <= *line && *line <= '9') {
+		if (*line == '6')
+			apip = API_PROTO_IPV6;
+		if (*line == '4')
+			apip = API_PROTO_IPV4;
+		line ++;
+		}
+
+#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
+
+	if ((line = lookup_ipaddr(&addr, line, apip)) == NULL) {
+		syslog(LOG_NOTICE, "[PING] unknown host.");
+		return;
+		}
+
+	line = skip_blanks(line);
+	if ('0' <= *line && *line <= '9')
+		line = get_int(&tmo, line);
+	else
+		tmo = 3;
+
+	line = skip_blanks(line);
+	if ('0' <= *line && *line <= '9')
+		line = get_int(&size, line);
+	else
+		size = 64;
+
+#if defined(SUPPORT_INET6)
+
+#if defined(SUPPORT_INET4)
+
+	if (apip == API_PROTO_IPV6) {
+		syslog(LOG_NOTICE, "[PING6] size: %d, tmo: %d, host: %s", size, tmo, ipv62str(NULL, &addr));
+		ping6(&addr, (uint_t)tmo, (uint_t)size);
+		}
+	else {
+		addr4 = ntohl(addr.s6_addr32[3]);
+		syslog(LOG_NOTICE, "[PING4] size: %d, tmo: %d, host: %s", size, tmo, ip2str(NULL, &addr4));
+		ping4(&addr4, (uint_t)tmo, (uint_t)size);
+		}
+
+#else /* of #if defined(SUPPORT_INET4) */
+
+	syslog(LOG_NOTICE, "[PING6] size: %d, tmo: %d, host: %s", size, tmo, ipv62str(NULL, &addr));
+	ping6(&addr, (uint_t)tmo, (uint_t)size);
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+#else	/* of #if defined(SUPPORT_INET6) */
+
+
+	syslog(LOG_NOTICE, "[PING4] size: %d, tmo: %d, host: %s", size, tmo, ip2str(NULL, &addr));
+	ping4(&addr, (uint_t)tmo, (uint_t)size);
+
+#endif	/* of #if defined(SUPPORT_INET6) */
+
+	}
+
+#endif	/* of #ifdef USE_PING */
+
+#ifdef USE_DBG_CONS_PARSER
+
 /*
  *  デバッグコマンド解析
  */
 
-static void
+void
 dbg_parse (ID portid, char *line)
 {
 	int_t	cepid;
-	ER	error;
+	ER	error = E_OK;
+
+#if defined(SUPPORT_UDP) && defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
+	int_t	udp_cep_ipproto;
+#endif
 
 	switch (*line) {
@@ -1870,5 +2599,5 @@
 
 		case 'f':	/* show configurations */
-			show_config(portid, line + 1);
+			dbg_cons_show_config(portid, line + 1);
 			break;
 
@@ -1880,5 +2609,5 @@
 				line ++;
 			if ((error = tcp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK && error != E_RLWAI) {
-				cons_printf(portid, "[TCP CAN CEP] error: %s\n", itron_strerror(error));
+				cons_printf(portid, "[TCP CAN CEP] error: %s.\n", itron_strerror(error));
 				SIG_NET_CONS_PRINTF();
 				FLUSH_SND_BUFF();
@@ -1891,12 +2620,78 @@
 
 		case 'u':	/* cancel UDP */
+
+#if defined(SUPPORT_INET6)
+
+#if defined(SUPPORT_INET4)
+
+			udp_cep_ipproto = (*(line + 2) == '4' ? API_PROTO_IPV4 : API_PROTO_IPV6);
+			cepid = atoi(line = skip_blanks(line + 3));
+			while ('0' <= *line && *line <= '9')
+				line ++;
+
+#if TNUM_UDP6_CEPID > 0
+
+			if (udp_cep_ipproto == API_PROTO_IPV6) {
+				if ((error = udp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK && error != E_RLWAI) {
+					cons_printf(portid, "[UDP CAN CEP] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+				}
+
+#endif	/* of #if TNUM_UDP6_CEPID > 0 */
+
+#if TNUM_UDP4_CEPID > 0
+
+			if (udp_cep_ipproto == API_PROTO_IPV4) {
+				if ((error = udp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK && error != E_RLWAI) {
+					cons_printf(portid, "[UDP CAN CEP] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+				}
+
+#endif	/* of #if TNUM_UDP4_CEPID > 0 */
+
+#else	/* of #if defined(SUPPORT_INET4) */
+
+#if TNUM_UDP6_CEPID > 0
+
 			cepid = atoi(line = skip_blanks(line + 2));
 			while ('0' <= *line && *line <= '9')
 				line ++;
+
 			if ((error = udp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK && error != E_RLWAI) {
-				cons_printf(portid, "[UDP CAN CEP] error: %s\n", itron_strerror(error));
+				cons_printf(portid, "[UDP CAN CEP] error: %s.\n", itron_strerror(error));
 				SIG_NET_CONS_PRINTF();
 				FLUSH_SND_BUFF();
 				}
+
+#endif	/* of #if TNUM_UDP6_CEPID > 0 */
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+#else	/* of #if defined(SUPPORT_INET6) */
+
+#if defined(SUPPORT_INET4)
+
+#if TNUM_UDP4_CEPID > 0
+
+			cepid = atoi(line = skip_blanks(line + 2));
+			while ('0' <= *line && *line <= '9')
+				line ++;
+
+			if ((error = udp_can_cep((ID)cepid, atoi(skip_blanks(line)))) != E_OK && error != E_RLWAI) {
+				cons_printf(portid, "[UDP CAN CEP] error: %s.\n", itron_strerror(error));
+				SIG_NET_CONS_PRINTF();
+				FLUSH_SND_BUFF();
+				}
+
+#endif	/* of #if TNUM_UDP4_CEPID > 0 */
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+#endif	/* of #if defined(SUPPORT_INET6) */
+
 			break;
 
@@ -1906,6 +2701,4 @@
 
 		break;
-
-#if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI) || defined(SUPPORT_PPP) || defined(SUPPORT_ETHER) && defined(USE_NET_CONS)
 
 	case 'd':	/* discard client */
@@ -1929,4 +2722,12 @@
 #endif	/* of #if defined(SUPPORT_ETHER) && defined(USE_NET_CONS) */
 
+#if defined(DHCP6_CLI_CFG) || defined(DHCP4_CLI_CFG)
+
+		case 'h':		/* DHCP client */
+			dhcpc(portid, line + 2);
+			break;
+
+#endif	/* of #if defined(DHCP6_CLI_CFG) || defined(DHCP4_CLI_CFG) */
+
 #ifdef USE_TCP_DISCARD_CLI
 
@@ -1941,5 +2742,5 @@
 			default:
 				if ((error = psnd_dtq(DTQ_TCP_DISCARD_CLI, (intptr_t)line)) != E_OK) {
-					cons_printf(portid, "[TCP DISCARD CLI] error: %s\n",
+					cons_printf(portid, "[TCP DISCARD CLI] error: %s.\n",
 					       itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
@@ -1965,5 +2766,5 @@
 			default:
 				if ((error = psnd_dtq(DTQ_UDP_DISCARD_CLI, (intptr_t)line)) != E_OK) {
-					cons_printf(portid, "[UDP DISCARD CLI] error: %s\n",
+					cons_printf(portid, "[UDP DISCARD CLI] error: %s.\n",
 					       itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
@@ -1981,7 +2782,5 @@
 		break;
 
-#endif	/* of #if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI) || defined(SUPPORT_PPP) || defined(SUPPORT_ETHER) && defined(USE_NET_CONS) */
-
-#if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI)
+#if defined(USE_TCP_ECHO_CLI) || defined(USE_UDP_ECHO_CLI)
 
 	case 'e':	/* echo client */
@@ -2000,5 +2799,5 @@
 			default:
 				if ((error = psnd_dtq(DTQ_TCP_ECHO_CLI_SND, (intptr_t)line)) != E_OK) {
-					cons_printf(portid, "[TCP ECHO CLI] error: %s\n", itron_strerror(error));
+					cons_printf(portid, "[TCP ECHO CLI] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
@@ -2011,20 +2810,79 @@
 #endif	/* of #ifdef USE_TCP_ECHO_CLI */
 
-#ifdef USE_UDP_ECHO_CLI
+#if defined(USE_UDP_ECHO_CLI)
 
 		case 'u':	/* UDP echo client */
-			line += 2;
-			switch (*line) {
+			switch (*(line + 2)) {
 
 			case 's':	/* cancel UDP echo */
-				udp_echo_cli_valid = false;
+
+#if defined(USE_UDP6_ECHO_CLI_TSK)
+
+#if defined(USE_UDP4_ECHO_CLI_TSK)
+
+				if (*(line + 3) == '4')
+					udp4_echo_cli_valid = false;
+				else
+					udp6_echo_cli_valid = false;
+
+#else	/* of #if defined(USE_UDP4_ECHO_CLI_TSK) */
+
+				udp6_echo_cli_valid = false;
+
+#endif	/* of #if defined(USE_UDP4_ECHO_CLI_TSK) */
+
+#else	/* of #if defined(USE_UDP6_ECHO_CLI_TSK) */
+
+#if defined(USE_UDP4_CLI_TSK)
+
+				udp4_echo_cli_valid = false;
+
+#endif	/* of #if defined(USE_UDP4_CLI_TSK) */
+
+#endif	/* of #if defined(USE_UDP6_ECHO_CLI_TSK) */
+
+
 				break;
 
 			default:
-				if ((error = psnd_dtq(DTQ_UDP_ECHO_CLI, (intptr_t)line)) != E_OK) {
-					cons_printf(portid, "[UDP ECHO CLI] error: %s\n", itron_strerror(error));
+
+				line += 2;
+
+#if defined(USE_UDP6_ECHO_CLI_TSK)
+
+#if defined(USE_UDP4_ECHO_CLI_TSK)
+
+				if (*line == '4') {
+					line ++;
+					error = psnd_dtq(DTQ_UDP4_ECHO_CLI, (intptr_t)line);
+					}
+				else {
+					if (*line && *line != ' ')
+						line ++;
+					error = psnd_dtq(DTQ_UDP6_ECHO_CLI, (intptr_t)line);
+					}
+
+#else	/* of #if defined(USE_UDP4_ECHO_CLI_TSK) */
+
+				if (*line && *line != ' ')
+					line ++;
+				error = psnd_dtq(DTQ_UDP6_ECHO_CLI, (intptr_t)line);
+
+#endif	/* of #if defined(USE_UDP4_ECHO_CLI_TSK) */
+
+#else	/* of #if defined(USE_UDP6_ECHO_CLI_TSK) */
+
+				if (*line && *line != ' ')
+					line ++;
+				error = psnd_dtq(DTQ_UDP4_ECHO_CLI, (intptr_t)line);
+
+#endif	/* of #if defined(USE_UDP6_ECHO_CLI_TSK) */
+
+				if (error != E_OK) {
+					cons_printf(portid, "[UDP ECHO CLI] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
 					}
+
 				break;
 
@@ -2032,5 +2890,5 @@
 			break;
 
-#endif	/* of #ifdef USE_UDP_ECHO_CLI */
+#endif	/* of #if defined(USE_UDP_ECHO_CLI) */
 
 			}
@@ -2038,10 +2896,21 @@
 		break;
 
-#endif	/* of #if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI) */
+#endif	/* of #if defined(USE_TCP_ECHO_CLI) || defined(USE_UDP_ECHO_CLI) */
 
 	case 'i':
 
-		if (*(line + 1) == 'f')
-			ifconfig(portid, line + 2);
+		if (*(line + 1) == 'f') {
+
+			dbg_cons_ifconfig (portid, line + 2);
+
+#if defined(NETAPP_IP6_CFG)
+			dbg_cons_ifconfig6(portid, line + 2);
+#endif
+
+#if defined(NETAPP_IP4_CFG)
+			dbg_cons_ifconfig4(portid, line + 2);
+#endif
+
+			}
 
 #ifdef SUPPORT_PPP
@@ -2064,5 +2933,5 @@
 
 	case 'n':		/* network status */
-		network_status(portid, line + 1);
+		dbg_cons_network_status(portid, line + 1);
 		break;
 
@@ -2070,40 +2939,10 @@
 
 		if (*(line + 1) == 's')
-			task_status(portid, skip_blanks(line + 2));
+			dbg_cons_task_status(portid, skip_blanks(line + 2));
 
 #ifdef USE_PING
 
-		else {
-			int_t		tmo, size;
-			T_IN_ADDR	addr;
-
-#ifdef PING_CFG_I6RLP
-			static const char i6rlp_pmtu_str1[] = " FF1E::1:2 1 1452";
-			static const char i6rlp_pmtu_str2[] = " FF1E::1:2 1 1352";
-			static const char i6rlp_pmtu_str3[] = " fe80::0200:00ff:fe00:0100 1 2";
-
-			if      (*(line + 1) == '1')
-				strcpy(line + 1, i6rlp_pmtu_str1);
-			else if (*(line + 1) == '2')
-				strcpy(line + 1, i6rlp_pmtu_str2);
-			else if (*(line + 1) == '3')
-				strcpy(line + 1, i6rlp_pmtu_str3);
-
-#endif	/* of #ifdef PING_CFG_I6RLP */
-
-			line = skip_blanks(GET_IPADDR(&addr, skip_blanks(line + 1)));
-			if ('0' <= *line && *line <= '9')
-				line = get_int(&tmo, line);
-			else
-				tmo = 3;
-
-			line = skip_blanks(line + 1);
-			if ('0' <= *line && *line <= '9')
-				line = get_int(&size, line);
-			else
-				size = 64;
-
-			PING(&addr, (uint_t)tmo, (uint_t)size);
-			}
+		else
+			dbg_cons_ping_comd(portid, line + 1);
 
 #endif	/* of #ifdef USE_PING */
@@ -2113,5 +2952,5 @@
 	case 'r':		/* release wait task */
 		if ((error = rel_wai(atoi(skip_blanks(line + 1)))) != E_OK) {
-			cons_printf(portid, "[REL WAI TSK] error: %s\n", itron_strerror(error));
+			cons_printf(portid, "[REL WAI TSK] error: %s.\n", itron_strerror(error));
 			SIG_NET_CONS_PRINTF();
 			FLUSH_SND_BUFF();
@@ -2125,6 +2964,10 @@
 
 		case 't':		/* TCP REP */
-			if ((error = tcp_del_rep(atoi(skip_blanks(line + 2)))) != E_OK) {
-				cons_printf(portid, "[TCP DEL REP] error: %s\n", itron_strerror(error));
+	
+			error = tcp_del_rep(atoi(skip_blanks(line + 2)));
+			if (error != E_OK) {
+				cons_printf(portid, "[TCP DEL REP] ID: %d, error: %s.\n", 
+				                    atoi(skip_blanks(line + 2)),
+				                    itron_strerror(error));
 				SIG_NET_CONS_PRINTF();
 				FLUSH_SND_BUFF();
@@ -2137,9 +2980,48 @@
 
 		case 'u':		/* UDP CEP */
-			if ((error = udp_del_cep(atoi(skip_blanks(line + 2)))) != E_OK) {
-				cons_printf(portid, "[UDP DEL CEP] error: %s\n", itron_strerror(error));
+
+#if defined(USE_UDP6_ECHO_SRV_TSK)
+
+#if defined(USE_UDP4_ECHO_SRV_TSK)
+
+			if (*(line + 2) == '4') {
+				if ((error = udp_del_cep(atoi(skip_blanks(line + 3)))) != E_OK) {
+					cons_printf(portid, "[UDP DEL CEP] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+				}
+			else {
+				if ((error = udp6_del_cep(atoi(skip_blanks(line + 2)))) != E_OK) {
+					cons_printf(portid, "[UDP DEL CEP] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+				}
+
+#else	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+			if ((error = udp6_del_cep(atoi(skip_blanks(line + 2)))) != E_OK) {
+				cons_printf(portid, "[UDP DEL CEP] error: %s.\n", itron_strerror(error));
 				SIG_NET_CONS_PRINTF();
 				FLUSH_SND_BUFF();
 				}
+
+#endif	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+#else	/* of #if defined(USE_UDP6_ECHO_SRV_TSK) */
+
+#if defined(USE_UDP4_ECHO_SRV_TSK)
+
+			if ((error = udp_del_cep(atoi(skip_blanks(line + 2)))) != E_OK) {
+				cons_printf(portid, "[UDP DEL CEP] error: %s.\n", itron_strerror(error));
+				SIG_NET_CONS_PRINTF();
+				FLUSH_SND_BUFF();
+				}
+
+#endif	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+#endif	/* of #if defined(USE_UDP6_ECHO_SRV_TSK) */
+
 			break;
 
@@ -2163,5 +3045,5 @@
 			case 'd':		/* tcp discard server */
 				if ((error = wup_tsk(TCP_DISCARD_SRV_TASK)) != E_OK) {
-					cons_printf(portid, "[WUP TCP DISCARD SRV] error: %s\n", itron_strerror(error));
+					//cons_printf(portid, "[WUP TCP DISCARD SRV] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
@@ -2170,18 +3052,28 @@
 #endif	/* of #ifdef USE_TCP_DISCARD_SRV */
 
-#if defined(USE_TCP_ECHO_SRV1) || defined(USE_TCP_ECHO_SRV2)
+#if defined(USE_TCP_ECHO_SRV1)
 			case 'e':		/* tcp echo server */
-				if ((error = wup_tsk(TCP_ECHO_SRV_TASK)) != E_OK) {
-					cons_printf(portid, "[WUP UDP DISCARD SRV] error: %s\n", itron_strerror(error));
+				if ((error = wakeup_tcp_echo_srv((*(line + 3) == '4' ? API_PROTO_IPV4 : API_PROTO_IPV6))) != E_OK) {
+					//cons_printf(portid, "[WUP TCP ECHO SRV] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
 					}
 				break;
-#endif	/* of #if defined(USE_TCP_ECHO_SRV1) || defined(USE_TCP_ECHO_SRV2) */
+#endif	/* of #if defined(USE_TCP_ECHO_SRV1) */
+
+#if defined(USE_TCP_ECHO_SRV2)
+			case 'e':		/* tcp echo server */
+				if ((error = wup_tsk(TCP_ECHO_SRV_TASK2)) != E_OK) {
+					//cons_printf(portid, "[WUP TCP ECHO SRV] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+				break;
+#endif	/* of #if defined(USE_TCP_ECHO_SRV2) */
 
 #ifdef USE_WWW_SRV
 			case 'w':		/* WWW server */
-				if ((error = wup_tsk(WWW_SRV_TASK1)) != E_OK) {
-					cons_printf(portid, "[WUP WWW SRV] error: %s\n", itron_strerror(error));
+				if ((error = wakeup_www_srv((*(line + 3) == '4' ? API_PROTO_IPV4 : API_PROTO_IPV6))) != E_OK) {
+					//cons_printf(portid, "[WUP WWW SRV] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
@@ -2200,13 +3092,54 @@
 			switch (*(line + 2)) {
 
-#if defined(USE_UDP_ECHO_SRV) && !defined(USE_UDP_CALL_BACK)
+#if !defined(USE_UDP_CALL_BACK)
+
 			case 'e':		/* udp echo server */
-				if ((error = wup_tsk(UDP_ECHO_SRV_TASK)) != E_OK) {
-					cons_printf(portid, "[WUP UDP ECHO SRV] error: %s\n", itron_strerror(error));
+
+#if defined(USE_UDP6_ECHO_SRV_TSK)
+
+#if defined(USE_UDP4_ECHO_SRV_TSK)
+
+				if (*(line + 3) == '4') {
+					if ((error = wup_tsk(UDP4_ECHO_SRV_TASK)) != E_OK) {
+						cons_printf(portid, "[WUP UDP4 ECHO SRV] error: %s.\n", itron_strerror(error));
+						SIG_NET_CONS_PRINTF();
+						FLUSH_SND_BUFF();
+						}
+					}
+				else {
+					if ((error = wup_tsk(UDP6_ECHO_SRV_TASK)) != E_OK) {
+						cons_printf(portid, "[WUP UDP6 ECHO SRV] error: %s.\n", itron_strerror(error));
+						SIG_NET_CONS_PRINTF();
+						FLUSH_SND_BUFF();
+						}
+					}
+
+#else	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+				if ((error = wup_tsk(UDP6_ECHO_SRV_TASK)) != E_OK) {
+					cons_printf(portid, "[WUP UDP6 ECHO SRV] error: %s.\n", itron_strerror(error));
 					SIG_NET_CONS_PRINTF();
 					FLUSH_SND_BUFF();
 					}
+
+#endif	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+#else	/* of #if defined(USE_UDP6_ECHO_SRV_TSK) */
+
+#if defined(USE_UDP4_ECHO_SRV_TSK)
+
+				if ((error = wup_tsk(UDP4_ECHO_SRV_TASK)) != E_OK) {
+					cons_printf(portid, "[WUP UDP4 ECHO SRV] error: %s.\n", itron_strerror(error));
+					SIG_NET_CONS_PRINTF();
+					FLUSH_SND_BUFF();
+					}
+
+#endif	/* of #if defined(USE_UDP4_ECHO_SRV_TSK) */
+
+#endif	/* of #if defined(USE_UDP6_ECHO_SRV_TSK) */
+
 				break;
-#endif	/* of #if defined(USE_UDP_ECHO_SRV) && !defined(USE_UDP_CALL_BACK) */
+
+#endif	/* of #if !defined(USE_UDP_CALL_BACK) */
 
 				}
@@ -2217,5 +3150,5 @@
 		default:
 			if ((error = wup_tsk(atoi(skip_blanks(line + 1)))) != E_OK) {
-				cons_printf(portid, "[WUP TSK] error: %s\n", itron_strerror(error));
+				cons_printf(portid, "[WUP TSK] error: %s.\n", itron_strerror(error));
 				SIG_NET_CONS_PRINTF();
 				FLUSH_SND_BUFF();
@@ -2230,5 +3163,5 @@
 	case 'w':		/* wake up task */
 		if ((error = wup_tsk(atoi(skip_blanks(line + 1)))) != E_OK) {
-			cons_printf(portid, "[WUP TSK] error: %s\n", itron_strerror(error));
+			cons_printf(portid, "[WUP TSK] error: %s.\n", itron_strerror(error));
 			SIG_NET_CONS_PRINTF();
 			FLUSH_SND_BUFF();
@@ -2242,15 +3175,17 @@
 		if (*line) {
 
-#ifdef USE_EXTRA_PARSE
-
-			extra_parse(line);
-
-#else	/* of #ifdef USE_EXTRA_PARSE */
-
-			cons_printf(portid, "no such command: '%c'\n", *line);
+#ifdef USE_DBG_CONS_EXTRA_PARSE
+
+			//cons_printf(portid, "extra command: '%c'.\n", *line);
+			dbg_cons_extra_parse(portid, line);
+
+#else	/* of #ifdef USE_DBG_CONS_EXTRA_PARSE */
+
+			//cons_printf(portid, "command: '%c'.\n", *line);
+			cons_printf(portid, "no such command: '%c'.\n", *line);
 			SIG_NET_CONS_PRINTF();
 			FLUSH_SND_BUFF();
 
-#endif	/* of #ifdef USE_EXTRA_PARSE */
+#endif	/* of #ifdef USE_DBG_CONS_EXTRA_PARSE */
 
 			}
@@ -2258,4 +3193,6 @@
 		}
 	}
+
+#endif	/* of #ifdef USE_DBG_CONS_PARSER */
 
 /*
@@ -2268,5 +3205,4 @@
 	static char line[DBG_LINE_SIZE + 1];
 
-	uint_t	len;
 	ID	tskid;
 
@@ -2274,49 +3210,60 @@
 #ifdef SUPPORT_ETHER
 
+#if 0
 #if defined(SUPPORT_INET6)
 
-	int_t		lllen;
+	uint32_t	lllen;
 	const uint8_t	*lladdr;
 
 #endif	/* of #if defined(SUPPORT_INET6) */
-
-	lcd_init();
+#endif
+
+	lcd_initialize(0);
+
+#if 0
+#if defined(SUPPORT_INET6)
+
+	dly_tsk(1 * 1000);
+	lladdr = IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr;
+	for (lllen = ETHER_ADDR_LEN; lllen --; )
+		lcd_printf(LCD_PORTID, "%02x", *lladdr ++);
+	lcd_putc(LCD_PORTID, '\n');
+
+#else	/* of #if defined(SUPPORT_INET6) */
 
 	if ((TINET_PRVER & UINT_C(0x0f)) > 0)
-		lcd_printf("TINET-%d.%d.%d\n",
+		lcd_printf(LCD_PORTID, "TINET-%d.%d.%d\n",
 		       (TINET_PRVER   >> 12) & UINT_C(0x0f),
 		       (TINET_PRVER   >>  4) & UINT_C(0x0f),
 		        TINET_PRVER          & UINT_C(0x0f));
 	else
-		lcd_printf("TINET-%d.%d\n",
+		lcd_printf(LCD_PORTID, "TINET-%d.%d\n",
 		       (TINET_PRVER   >> 12) & UINT_C(0x0f),
 		       (TINET_PRVER   >>  4) & UINT_C(0x0f));
 
-#if defined(SUPPORT_INET6)
-
-	lladdr = IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr;
-	for (lllen = ETHER_ADDR_LEN; lllen --; )
-		lcd_printf("%02x", *lladdr ++);
-	lcd_printf("\n");
-
-#else	/* of #if defined(SUPPORT_INET6) */
-
-	lcd_puts(ip2str(NULL, in4_get_ifaddr(0)));
-
 #endif	/* of #if defined(SUPPORT_INET6) */
+#endif
+
+#if 0
+#if defined(SUPPORT_INET4)
+
+	dly_tsk(1 * 1000);
+	lcd_puts(LCD_PORTID, ip2str(NULL, in4_get_ifaddr(0)));
+	lcd_putc(LCD_PORTID, '\n');
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+#endif
 
 #endif	/* of #ifdef SUPPORT_ETHER */
-#else	/* of #ifdef USE_LCD */
+#endif	/* of #ifdef USE_LCD */
 
 	get_tid(&tskid);
 	cons_printf(CONSOLE_PORTID, "[CONSOLE:%d] started.\n", tskid);
-
-#endif	/* of #ifdef USE_LCD */
-
 	serial_ctl_por(CONSOLE_PORTID,
 	               IOCTL_ECHO  | IOCTL_CRLF  |
 	               IOCTL_FCSND | IOCTL_FCANY | IOCTL_FCRCV);
+	netapp_srand (tskid);
 	while (true) {
-		len = cons_getline(CONSOLE_PORTID, line, DBG_LINE_SIZE);
+		cons_getline(CONSOLE_PORTID, line, DBG_LINE_SIZE);
 		dbg_parse(CONSOLE_PORTID, line);
 		}
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.cfg	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.cfg	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -53,5 +53,13 @@
 
 extern void act_tasks (void);
-extern void extra_parse (char *line);
+extern void dbg_parse (ID portid, char *line);
+extern void dbg_cons_extra_parse (ID portid, char *line);
+extern void dbg_cons_task_status (ID portid, char *line);
+extern void dbg_cons_network_status (ID portid, char *line);
+extern void dbg_cons_ifconfig (ID portid, char *line);
+extern void dbg_cons_ifconfig6 (ID portid, char *line);
+extern void dbg_cons_ifconfig4 (ID portid, char *line);
+extern void dbg_cons_show_config (ID portid, char *line);
+extern void dbg_cons_ping_comd (ID portid, char *line);
 
 #endif	/* of #ifndef _DBG_CONS_ */
